Index: NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/diaobs.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/diaobs.F90	(revision 15731)
+++ NEMO/branches/UKMO/NEMO_4.0.4_FOAM_package/src/OCE/OBS/diaobs.F90	(revision 15799)
@@ -382,101 +197,169 @@
       !-----------------------------------------------------------------------
       !
-      IF( nproftypes > 0 ) THEN
-         !
-         ALLOCATE( profdata  (nproftypes) , nvarsprof (nproftypes) )
-         ALLOCATE( profdataqc(nproftypes) , nextrprof (nproftypes) )
-         !
-         DO jtype = 1, nproftypes
-            !
-            nvarsprof(jtype) = 2
-            IF ( TRIM(cobstypesprof(jtype)) == 'prof' ) THEN
-               nextrprof(jtype) = 1
-               llvar1 = ln_t3d
-               llvar2 = ln_s3d
-               zglam1 = glamt
-               zgphi1 = gphit
-               zmask1 = tmask
-               zglam2 = glamt
-               zgphi2 = gphit
-               zmask2 = tmask
+      DO jgroup = 1, nn_obsgroups
+         IF ( sobsgroups(jgroup)%lenabled ) THEN
+            IF ( sobsgroups(jgroup)%lprof ) THEN
+               !
+               ! Read in profile or profile obs types
+               !
+               ALLOCATE( llvar(sobsgroups(jgroup)%nobstypes) )
+               llvar(:) = .TRUE.
+               !
+               CALL obs_rea_prof( sobsgroups(jgroup)%sprofdata,   &
+                  &               sobsgroups(jgroup)%nobsfiles,   &
+                  &               sobsgroups(jgroup)%cobsfiles,   &
+                  &               sobsgroups(jgroup)%nobstypes,   &
+                  &               sobsgroups(jgroup)%naddvars,    &
+                  &               sobsgroups(jgroup)%nextvars,    &
+                  &               nitend-nit000+2,                &
+                  &               rn_dobsini,                     &
+                  &               rn_dobsend,                     &
+                  &               llvar,                          &
+                  &               sobsgroups(jgroup)%lignmis,     &
+                  &               sobsgroups(jgroup)%lall_at_all, &
+                  &               .FALSE.,                        &
+                  &               sobsgroups(jgroup)%cobstypes,   &
+                  &               kdailyavtypes = sobsgroups(jgroup)%nprofdavtypes )
+               !
+               DO jvar = 1, sobsgroups(jgroup)%nobstypes
+                  CALL obs_prof_staend( sobsgroups(jgroup)%sprofdata, jvar )
+               END DO
+               !
+               IF ( sobsgroups(jgroup)%sprofdata%next > 0 ) THEN
+                  CALL obs_prof_staend_ext( sobsgroups(jgroup)%sprofdata )
+               ENDIF
+               !
+               IF( sobsgroups(jgroup)%loutput_clim ) THEN
+                  sobsgroups(jgroup)%sprofdata%caddvars(sobsgroups(jgroup)%nadd_clm)  = 'CLM'
+                  DO jvar = 1, sobsgroups(jgroup)%nobstypes
+                     sobsgroups(jgroup)%sprofdata%var(jvar)%vadd(:,sobsgroups(jgroup)%nadd_clm) = fbrmdi
+                     sobsgroups(jgroup)%sprofdata%caddlong(sobsgroups(jgroup)%nadd_clm,jvar) = 'Climatology'
+                     sobsgroups(jgroup)%sprofdata%caddunit(sobsgroups(jgroup)%nadd_clm,jvar) = sobsgroups(jgroup)%sprofdata%cunit(jvar)
+                  END DO
+               ENDIF
+               !
+               sobsgroups(jgroup)%sprofdata%cgrid = sobsgroups(jgroup)%cgrid
+               !
+               CALL obs_pre_prof( sobsgroups(jgroup)%sprofdata,     &
+                  &               sobsgroups(jgroup)%sprofdataqc,   &
+                  &               llvar,                            &
+                  &               jpi, jpj, jpk,                    &
+                  &               sobsgroups(jgroup)%rmask,         &
+                  &               sobsgroups(jgroup)%rglam,         &
+                  &               sobsgroups(jgroup)%rgphi,         &
+                  &               sobsgroups(jgroup)%lnea,          &
+                  &               sobsgroups(jgroup)%lbound_reject, &
+                  &               kdailyavtypes = sobsgroups(jgroup)%nprofdavtypes )
+               !
+               DEALLOCATE( llvar )
+               !
+            ELSEIF (sobsgroups(jgroup)%lsurf) THEN
+               !
+               ! Read in surface obs types
+               !
+               CALL obs_rea_surf( sobsgroups(jgroup)%ssurfdata,         &
+                  &               sobsgroups(jgroup)%nobsfiles,         &
+                  &               sobsgroups(jgroup)%cobsfiles,         &
+                  &               sobsgroups(jgroup)%nobstypes,         &
+                  &               sobsgroups(jgroup)%naddvars,          &
+                  &               sobsgroups(jgroup)%nextvars,          &
+                  &               nitend-nit000+2,                      &
+                  &               rn_dobsini,                           &
+                  &               rn_dobsend,                           &
+                  &               sobsgroups(jgroup)%rtime_mean_period, &
+                  &               sobsgroups(jgroup)%ltime_mean_bkg,    &
+                  &               sobsgroups(jgroup)%lignmis,           &
+                  &               .FALSE.,                              &
+                  &               sobsgroups(jgroup)%lnight,            &
+                  &               sobsgroups(jgroup)%cobstypes )
+               !
+               IF( sobsgroups(jgroup)%lsla ) THEN
+                  sobsgroups(jgroup)%ssurfdata%cextvars(sobsgroups(jgroup)%next_mdt) = 'MDT'
+                  sobsgroups(jgroup)%ssurfdata%cextlong(sobsgroups(jgroup)%next_mdt) = 'Mean dynamic topography'
+                  sobsgroups(jgroup)%ssurfdata%cextunit(sobsgroups(jgroup)%next_mdt) = 'Metres'
+                  sobsgroups(jgroup)%ssurfdata%caddvars(sobsgroups(jgroup)%nadd_ssh) = 'SSH'
+                  DO jvar = 1, sobsgroups(jgroup)%nobstypes
+                     sobsgroups(jgroup)%ssurfdata%caddlong(sobsgroups(jgroup)%nadd_ssh,jvar) = 'Model Sea surface height'
+                     sobsgroups(jgroup)%ssurfdata%caddunit(sobsgroups(jgroup)%nadd_ssh,jvar) = 'Metres'
+                  END DO
+               ENDIF
+               !
+               IF( sobsgroups(jgroup)%lfbd ) THEN
+                  sobsgroups(jgroup)%ssurfdata%cextvars(sobsgroups(jgroup)%next_snow) = 'SNOW'
+                  sobsgroups(jgroup)%ssurfdata%cextlong(sobsgroups(jgroup)%next_snow) = 'Snow thickness'
+                  sobsgroups(jgroup)%ssurfdata%cextunit(sobsgroups(jgroup)%next_snow) = 'Metres'
+                  sobsgroups(jgroup)%ssurfdata%caddvars(sobsgroups(jgroup)%nadd_fbd)  = 'FBD'
+                  DO jvar = 1, sobsgroups(jgroup)%nobstypes
+                     sobsgroups(jgroup)%ssurfdata%caddlong(sobsgroups(jgroup)%nadd_fbd,jvar) = 'Freeboard'
+                     sobsgroups(jgroup)%ssurfdata%caddunit(sobsgroups(jgroup)%nadd_fbd,jvar) = 'Metres'
+                  END DO
+               ENDIF
+               !
+               IF( sobsgroups(jgroup)%loutput_clim ) THEN
+                  sobsgroups(jgroup)%ssurfdata%caddvars(sobsgroups(jgroup)%nadd_clm)  = 'CLM'
+                  DO jvar = 1, sobsgroups(jgroup)%nobstypes
+                     sobsgroups(jgroup)%ssurfdata%radd(:,:,jvar) = fbrmdi
+                     sobsgroups(jgroup)%ssurfdata%caddlong(sobsgroups(jgroup)%nadd_clm,jvar) = 'Climatology'
+                     sobsgroups(jgroup)%ssurfdata%caddunit(sobsgroups(jgroup)%nadd_clm,jvar) = sobsgroups(jgroup)%ssurfdata%cunit(jvar)
+                  END DO
+               ENDIF
+               !
+               sobsgroups(jgroup)%ssurfdata%cgrid = sobsgroups(jgroup)%cgrid
+               !
+               CALL obs_pre_surf( sobsgroups(jgroup)%ssurfdata,      &
+                  &               sobsgroups(jgroup)%ssurfdataqc,    &
+                  &               jpi, jpj,                          &
+                  &               sobsgroups(jgroup)%rmask(:,:,1,:), &
+                  &               sobsgroups(jgroup)%rglam,          &
+                  &               sobsgroups(jgroup)%rgphi,          &
+                  &               sobsgroups(jgroup)%lnea,           &
+                  &               sobsgroups(jgroup)%lbound_reject )
+               !
+               IF( sobsgroups(jgroup)%lsla ) THEN
+                  CALL obs_rea_mdt( sobsgroups(jgroup)%ssurfdataqc, &
+                     &              sobsgroups(jgroup)%n2dint,      &
+                     &              sobsgroups(jgroup)%next_mdt,    &
+                     &              sobsgroups(jgroup)%nmsshc,      &
+                     &              sobsgroups(jgroup)%rmdtcorr,    &
+                     &              sobsgroups(jgroup)%rmdtcutoff )
+                  IF( sobsgroups(jgroup)%laltbias ) THEN
+                     CALL obs_app_bias( sobsgroups(jgroup)%ssurfdataqc,   &
+                        &               sobsgroups(jgroup)%next_mdt,      & 
+                        &               sobsgroups(jgroup)%n2dint,        & 
+                        &               1,                                &
+                        &               sobsgroups(jgroup)%caltbiasfile,  &
+                        &               'altbias',                        &
+                        &               ld_extvar=.TRUE. ) 
+                  ENDIF
+               ENDIF
+               !
+#if defined key_si3
+               IF( sobsgroups(jgroup)%lfbd ) THEN
+                  CALL obs_rea_snowdepth( sobsgroups(jgroup)%ssurfdataqc, &
+                     &                    sobsgroups(jgroup)%n2dint,      &
+                     &                    sobsgroups(jgroup)%next_snow,   &
+                     &                    hm_s(:,:) )
+               ENDIF
+#elif defined key_cice
+               IF( sobsgroups(jgroup)%lfbd ) THEN
+                  CALL obs_rea_snowdepth( sobsgroups(jgroup)%ssurfdataqc, &
+                     &                    sobsgroups(jgroup)%n2dint,      &
+                     &                    sobsgroups(jgroup)%next_snow,   &
+                     &                    thick_s(:,:) )
+               ENDIF
+#endif
+               !
+               IF( sobsgroups(jgroup)%lobsbias ) THEN
+                  CALL obs_app_bias( sobsgroups(jgroup)%ssurfdataqc,   &
+                     &               sobsgroups(jgroup)%nbiasvar,      & 
+                     &               sobsgroups(jgroup)%n2dint,        & 
+                     &               sobsgroups(jgroup)%nobsbiasfiles, &
+                     &               sobsgroups(jgroup)%cobsbiasfiles, &
+                     &               sobsgroups(jgroup)%cbiasvarname ) 
+               ENDIF
+               !
             ENDIF
-            IF ( TRIM(cobstypesprof(jtype)) == 'vel' )  THEN
-               nextrprof(jtype) = 2
-               llvar1 = ln_vel3d
-               llvar2 = ln_vel3d
-               zglam1 = glamu
-               zgphi1 = gphiu
-               zmask1 = umask
-               zglam2 = glamv
-               zgphi2 = gphiv
-               zmask2 = vmask
-            ENDIF
-            !
-            ! Read in profile or profile obs types
-            CALL obs_rea_prof( profdata(jtype), ifilesprof(jtype),       &
-               &               clproffiles(jtype,1:ifilesprof(jtype)), &
-               &               nvarsprof(jtype), nextrprof(jtype), nitend-nit000+2, &
-               &               rn_dobsini, rn_dobsend, llvar1, llvar2, &
-               &               ln_ignmis, ln_s_at_t, .FALSE., &
-               &               kdailyavtypes = nn_profdavtypes )
-               !
-            DO jvar = 1, nvarsprof(jtype)
-               CALL obs_prof_staend( profdata(jtype), jvar )
-            END DO
-            !
-            CALL obs_pre_prof( profdata(jtype), profdataqc(jtype), &
-               &               llvar1, llvar2, &
-               &               jpi, jpj, jpk, &
-               &               zmask1, zglam1, zgphi1, zmask2, zglam2, zgphi2,  &
-               &               ln_nea, ln_bound_reject, &
-               &               kdailyavtypes = nn_profdavtypes )
-         END DO
-         !
-         DEALLOCATE( ifilesprof, clproffiles )
-         !
-      ENDIF
-      !
-      IF( nsurftypes > 0 ) THEN
-         !
-         ALLOCATE( surfdata  (nsurftypes) , nvarssurf(nsurftypes) )
-         ALLOCATE( surfdataqc(nsurftypes) , nextrsurf(nsurftypes) )
-         !
-         DO jtype = 1, nsurftypes
-            !
-            nvarssurf(jtype) = 1
-            nextrsurf(jtype) = 0
-            llnightav(jtype) = .FALSE.
-            IF( TRIM(cobstypessurf(jtype)) == 'sla' )   nextrsurf(jtype) = 2
-            IF( TRIM(cobstypessurf(jtype)) == 'sst' )   llnightav(jtype) = ln_sstnight
-            !
-            ! Read in surface obs types
-            CALL obs_rea_surf( surfdata(jtype), ifilessurf(jtype), &
-               &               clsurffiles(jtype,1:ifilessurf(jtype)), &
-               &               nvarssurf(jtype), nextrsurf(jtype), nitend-nit000+2, &
-               &               rn_dobsini, rn_dobsend, ln_ignmis, .FALSE., llnightav(jtype) )
-               !
-            CALL obs_pre_surf( surfdata(jtype), surfdataqc(jtype), ln_nea, ln_bound_reject )
-            !
-            IF( TRIM(cobstypessurf(jtype)) == 'sla' ) THEN
-               CALL obs_rea_mdt( surfdataqc(jtype), n2dintsurf(jtype) )
-               IF( ln_altbias )   &
-                  & CALL obs_rea_altbias ( surfdataqc(jtype), n2dintsurf(jtype), cn_altbiasfile )
-            ENDIF
-            !
-            IF( TRIM(cobstypessurf(jtype)) == 'sst' .AND. ln_sstbias ) THEN
-               jnumsstbias = 0
-               DO jfile = 1, jpmaxnfiles
-                  IF( TRIM(cn_sstbiasfiles(jfile)) /= '' )   jnumsstbias = jnumsstbias + 1
-               END DO
-               IF( jnumsstbias == 0 )   CALL ctl_stop("ln_sstbias set but no bias files to read in")    
-               !
-               CALL obs_app_sstbias( surfdataqc(jtype), n2dintsurf(jtype)             ,   & 
-                  &                  jnumsstbias      , cn_sstbiasfiles(1:jnumsstbias) ) 
-            ENDIF
-         END DO
-         !
-         DEALLOCATE( ifilessurf, clsurffiles )
-         !
-      ENDIF
+         ENDIF
+      END DO
       !
    END SUBROUTINE dia_obs_init
@@ -500,10 +383,11 @@
       USE oce    , ONLY : tsn, un, vn, sshn   ! Ocean dynamics and tracers variables
       USE phycst , ONLY : rday                ! Physical constants
-#if defined  key_si3
-      USE ice    , ONLY : at_i                ! SI3 Ice model variables
+#if defined key_si3
+      USE ice    , ONLY : at_i, hm_i          ! SI3 Ice model variables
+#elif defined key_cice
+      USE sbc_oce, ONLY : fr_i, thick_i       ! CICE Ice model variables
 #endif
-#if defined key_cice
-      USE sbc_oce, ONLY : fr_i     ! ice fraction
-#endif
+      USE tradmp,  ONLY : tclim, sclim        ! T&S climatology
+      USE obs_fbm, ONLY : fbrmdi              ! Real missing data indicator
 
       IMPLICIT NONE
@@ -513,23 +397,20 @@
       !! * Local declarations
       INTEGER :: idaystp           ! Number of timesteps per day
+      INTEGER :: imeanstp          ! Number of timesteps for time averaging
       INTEGER :: jtype             ! Data loop variable
       INTEGER :: jvar              ! Variable number
-      INTEGER :: ji, jj            ! Loop counters
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: &
-         & zprofvar1, &            ! Model values for 1st variable in a prof ob
-         & zprofvar2               ! Model values for 2nd variable in a prof ob
-      REAL(wp), DIMENSION(jpi,jpj,jpk) :: &
-         & zprofmask1, &           ! Mask associated with zprofvar1
-         & zprofmask2              ! Mask associated with zprofvar2
-      REAL(wp), DIMENSION(jpi,jpj) :: &
-         & zsurfvar, &             ! Model values equivalent to surface ob.
-         & zsurfmask               ! Mask associated with surface variable
-      REAL(wp), DIMENSION(jpi,jpj) :: &
-         & zglam1,    &            ! Model longitudes for prof variable 1
-         & zglam2,    &            ! Model longitudes for prof variable 2
-         & zgphi1,    &            ! Model latitudes for prof variable 1
-         & zgphi2                  ! Model latitudes for prof variable 2
-
-      !-----------------------------------------------------------------------
+      INTEGER :: jgroup
+      INTEGER :: ji, jj, jobs      ! Loop counters
+      LOGICAL :: lstp0             ! Flag special treatment on zeroth time step
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: &
+         & zprofvar, &             ! Model values for variables in a prof ob
+         & zprofclim               ! Climatology values for variables in a prof ob
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE :: &
+         & zsurfvar, &             ! Model values for variables in a surf ob
+         & zsurfclim               ! Climatology values for variables in a surf ob
+
+      !-----------------------------------------------------------------------
+
+      IF( ln_timing )   CALL timing_start('dia_obs')
 
       IF(lwp) THEN
@@ -545,89 +426,163 @@
       !-----------------------------------------------------------------------
 
-      IF ( nproftypes > 0 ) THEN
-
-         DO jtype = 1, nproftypes
-
-            SELECT CASE ( TRIM(cobstypesprof(jtype)) )
-            CASE('prof')
-               zprofvar1(:,:,:) = tsn(:,:,:,jp_tem)
-               zprofvar2(:,:,:) = tsn(:,:,:,jp_sal)
-               zprofmask1(:,:,:) = tmask(:,:,:)
-               zprofmask2(:,:,:) = tmask(:,:,:)
-               zglam1(:,:) = glamt(:,:)
-               zglam2(:,:) = glamt(:,:)
-               zgphi1(:,:) = gphit(:,:)
-               zgphi2(:,:) = gphit(:,:)
-            CASE('vel')
-               zprofvar1(:,:,:) = un(:,:,:)
-               zprofvar2(:,:,:) = vn(:,:,:)
-               zprofmask1(:,:,:) = umask(:,:,:)
-               zprofmask2(:,:,:) = vmask(:,:,:)
-               zglam1(:,:) = glamu(:,:)
-               zglam2(:,:) = glamv(:,:)
-               zgphi1(:,:) = gphiu(:,:)
-               zgphi2(:,:) = gphiv(:,:)
-            CASE DEFAULT
-               CALL ctl_stop( 'Unknown profile observation type '//TRIM(cobstypesprof(jtype))//' in dia_obs' )
-            END SELECT
-
-            CALL obs_prof_opt( profdataqc(jtype), kstp, jpi, jpj, jpk,  &
-               &               nit000, idaystp,                         &
-               &               zprofvar1, zprofvar2,                    &
-               &               gdept_n(:,:,:), gdepw_n(:,:,:),            & 
-               &               zprofmask1, zprofmask2,                  &
-               &               zglam1, zglam2, zgphi1, zgphi2,          &
-               &               nn_1dint, nn_2dint,                      &
-               &               kdailyavtypes = nn_profdavtypes )
-
-         END DO
-
-      ENDIF
-
-      IF ( nsurftypes > 0 ) THEN
-
-         DO jtype = 1, nsurftypes
-
-            !Defaults which might be changed
-            zsurfmask(:,:) = tmask(:,:,1)
-
-            SELECT CASE ( TRIM(cobstypessurf(jtype)) )
-            CASE('sst')
-               zsurfvar(:,:) = tsn(:,:,1,jp_tem)
-            CASE('sla')
-               zsurfvar(:,:) = sshn(:,:)
-            CASE('sss')
-               zsurfvar(:,:) = tsn(:,:,1,jp_sal)
-            CASE('sic')
-               IF ( kstp == 0 ) THEN
-                  IF ( lwp .AND. surfdataqc(jtype)%nsstpmpp(1) > 0 ) THEN
-                     CALL ctl_warn( 'Sea-ice not initialised on zeroth '// &
-                        &           'time-step but some obs are valid then.' )
-                     WRITE(numout,*)surfdataqc(jtype)%nsstpmpp(1), &
-                        &           ' sea-ice obs will be missed'
+      ALLOCATE( zprofvar(jpi,jpj,jpk),  &
+         &      zprofclim(jpi,jpj,jpk), &
+         &      zsurfvar(jpi,jpj),      &
+         &      zsurfclim(jpi,jpj) )
+
+      DO jgroup = 1, nn_obsgroups
+         IF ( sobsgroups(jgroup)%lenabled ) THEN
+
+            IF ( sobsgroups(jgroup)%lprof ) THEN
+
+               zprofclim(:,:,:) = fbrmdi
+
+               DO jvar = 1, sobsgroups(jgroup)%nobstypes
+
+                  SELECT CASE ( TRIM(sobsgroups(jgroup)%cobstypes(jvar)) )
+                  CASE('POTM')
+                     zprofvar(:,:,:) = tsn(:,:,:,jp_tem)
+                     IF (sobsgroups(jgroup)%loutput_clim) THEN
+                        zprofclim(:,:,:) = tclim(:,:,:)
+                     ENDIF
+                  CASE('PSAL')
+                     zprofvar(:,:,:) = tsn(:,:,:,jp_sal)
+                     IF (sobsgroups(jgroup)%loutput_clim) THEN
+                        zprofclim(:,:,:) = sclim(:,:,:)
+                     ENDIF
+                  CASE('UVEL')
+                     zprofvar(:,:,:) = un(:,:,:)
+                  CASE('VVEL')
+                     zprofvar(:,:,:) = vn(:,:,:)
+                  CASE DEFAULT
+                     CALL ctl_stop( 'Unknown profile observation type '//TRIM(sobsgroups(jgroup)%cobstypes(jvar))//' in dia_obs' )
+                  END SELECT
+
+                  CALL obs_prof_opt( sobsgroups(jgroup)%sprofdataqc,       &
+                     &               kstp, jpi, jpj, jpk,                  &
+                     &               nit000, idaystp, jvar,                &
+                     &               zprofvar,                             &
+                     &               sobsgroups(jgroup)%loutput_clim,      &
+                     &               sobsgroups(jgroup)%nadd_clm,          &
+                     &               zprofclim,                            &
+                     &               gdept_n,                              &
+                     &               gdepw_n,                              & 
+                     &               sobsgroups(jgroup)%rmask(:,:,:,jvar), &
+                     &               sobsgroups(jgroup)%rglam(:,:,jvar),   &
+                     &               sobsgroups(jgroup)%rgphi(:,:,jvar),   &
+                     &               sobsgroups(jgroup)%n1dint,            &
+                     &               sobsgroups(jgroup)%n2dint,            &
+                     &               kdailyavtypes = sobsgroups(jgroup)%nprofdavtypes )
+
+               END DO
+
+            ELSEIF (sobsgroups(jgroup)%lsurf) THEN
+
+               zsurfclim(:,:) = fbrmdi
+
+               DO jvar = 1, sobsgroups(jgroup)%nobstypes
+
+                  lstp0 = .FALSE.
+                  SELECT CASE ( TRIM(sobsgroups(jgroup)%cobstypes(jvar)) )
+                  CASE('SST')
+                     zsurfvar(:,:) = tsn(:,:,1,jp_tem)
+                     IF (sobsgroups(jgroup)%loutput_clim) THEN
+                        zsurfclim(:,:) = tclim(:,:,1)
+                     ENDIF
+                  CASE('SLA')
+                     zsurfvar(:,:) = sshn(:,:)
+                  CASE('SSS')
+                     zsurfvar(:,:) = tsn(:,:,1,jp_sal)
+                     IF (sobsgroups(jgroup)%loutput_clim) THEN
+                        zsurfclim(:,:) = sclim(:,:,1)
+                     ENDIF
+                  CASE('UVEL')
+                     zsurfvar(:,:) = un(:,:,1)
+                  CASE('VVEL')
+                     zsurfvar(:,:) = vn(:,:,1)
+                  CASE('ICECONC')
+                     IF ( kstp == 0 ) THEN
+                        lstp0 = .TRUE.
+                     ELSE
+#if defined key_si3
+                        zsurfvar(:,:) = at_i(:,:)
+#elif defined key_cice
+                        zsurfvar(:,:) = fr_i(:,:)
+#else
+                        CALL ctl_stop( ' Trying to run sea-ice observation operator', &
+                           &           ' but no sea-ice model appears to have been defined' )
+#endif
+                     ENDIF
+                  CASE('SIT','FBD')
+                     IF ( kstp == 0 ) THEN
+                        lstp0 = .TRUE.
+                     ELSE
+#if defined key_si3
+                        zsurfvar(:,:) = hm_i(:,:)
+#elif defined key_cice
+                        zsurfvar(:,:) = thick_i(:,:)
+#else
+                        CALL ctl_stop( ' Trying to run sea-ice observation operator', &
+                           &           ' but no sea-ice model appears to have been defined' )
+#endif
+                     ENDIF
+                  END SELECT
+
+                  IF ( lstp0 ) THEN
+                     IF ( sobsgroups(jgroup)%ssurfdataqc%nsstpmpp(1) > 0 ) THEN
+                        DO jobs = sobsgroups(jgroup)%ssurfdataqc%nsurfup + 1, &
+                           &      sobsgroups(jgroup)%ssurfdataqc%nsurfup + sobsgroups(jgroup)%ssurfdataqc%nsstp(1)
+                           sobsgroups(jgroup)%ssurfdata%nqc(jobs) = IBSET(sobsgroups(jgroup)%ssurfdata%nqc(jobs),13)
+                        END DO
+                        IF ( lwp ) THEN
+                           CALL ctl_warn( TRIM(sobsgroups(jgroup)%cobstypes(jvar))// &
+                              &           ' not initialised on zeroth '           // &
+                              &           'time-step but some obs are valid then.' )
+                           WRITE(numout,*)sobsgroups(jgroup)%ssurfdataqc%nsstpmpp(1), &
+                              &           TRIM(sobsgroups(jgroup)%cobstypes(jvar)),   &
+                              &           'observations will be flagged as bad'
+                        ENDIF
+                     ENDIF
+                     IF ( jvar == sobsgroups(jgroup)%ssurfdataqc%nvar ) THEN
+                        sobsgroups(jgroup)%ssurfdataqc%nsurfup = sobsgroups(jgroup)%ssurfdataqc%nsurfup + &
+                           &                                     sobsgroups(jgroup)%ssurfdataqc%nsstp(1)
+                     ENDIF
+                  ELSE
+                     IF ( sobsgroups(jgroup)%ltime_mean_bkg ) THEN
+                        ! Number of time-steps in meaning period
+                        imeanstp = NINT( ( sobsgroups(jgroup)%rtime_mean_period * 60.0 * 60.0 ) / rdt )
+                     ENDIF
+                     CALL obs_surf_opt( sobsgroups(jgroup)%ssurfdataqc,       &
+                        &               kstp, jpi, jpj,                       &
+                        &               nit000, idaystp,                      &
+                        &               jvar, zsurfvar,                       &
+                        &               sobsgroups(jgroup)%loutput_clim,      &
+                        &               sobsgroups(jgroup)%nadd_clm,          &
+                        &               zsurfclim,                            &
+                        &               sobsgroups(jgroup)%rmask(:,:,1,jvar), &
+                        &               sobsgroups(jgroup)%n2dint,            &
+                        &               sobsgroups(jgroup)%lnight,            &
+                        &               sobsgroups(jgroup)%ravglamscl,        &
+                        &               sobsgroups(jgroup)%ravgphiscl,        &
+                        &               sobsgroups(jgroup)%lfp_indegs,        &
+                        &               sobsgroups(jgroup)%ltime_mean_bkg,    &
+                        &               imeanstp,                             &
+                        &               kssh=sobsgroups(jgroup)%nadd_ssh,     &
+                        &               kmdt=sobsgroups(jgroup)%next_mdt,     &
+                        &               kfbd=sobsgroups(jgroup)%nadd_fbd,     &
+                        &               ksnow=sobsgroups(jgroup)%next_snow )
                   ENDIF
-                  surfdataqc(jtype)%nsurfup = surfdataqc(jtype)%nsurfup + &
-                     &                        surfdataqc(jtype)%nsstp(1)
-                  CYCLE
-               ELSE
-#if defined key_cice || defined key_si3
-                  zsurfvar(:,:) = fr_i(:,:)
-#else
-                  CALL ctl_stop( ' Trying to run sea-ice observation operator', &
-                     &           ' but no sea-ice model appears to have been defined' )
-#endif
-               ENDIF
-
-            END SELECT
-
-            CALL obs_surf_opt( surfdataqc(jtype), kstp, jpi, jpj,       &
-               &               nit000, idaystp, zsurfvar, zsurfmask,    &
-               &               n2dintsurf(jtype), llnightav(jtype),     &
-               &               zavglamscl(jtype), zavgphiscl(jtype),     &
-               &               lfpindegs(jtype) )
-
-         END DO
-
-      ENDIF
+
+               END DO
+
+            ENDIF
+
+         ENDIF
+      END DO
+
+      DEALLOCATE( zprofvar, zprofclim, &
+         &        zsurfvar, zsurfclim )
+
+      IF( ln_timing )   CALL timing_stop('dia_obs')
 
    END SUBROUTINE dia_obs
@@ -657,9 +612,14 @@
 
       !! * Local declarations
-      INTEGER :: jtype                    ! Data set loop variable
-      INTEGER :: jo, jvar, jk
+      INTEGER :: jgroup                   ! Data set loop variable
+      INTEGER :: jo, jvar, jk, jadd, jext, jadd2, jext2
+      INTEGER :: iuvar, ivvar
       REAL(wp), DIMENSION(:), ALLOCATABLE :: &
          & zu, &
          & zv
+      LOGICAL, DIMENSION(:), ALLOCATABLE :: ll_write
+      TYPE(obswriinfo) :: sladd, slext
+
+      IF( ln_timing )   CALL timing_start('dia_obs_wri')
 
       !-----------------------------------------------------------------------
